/*
Console Grabber
(c) 1998 GPL by Przemek Borys <pborys@p-soft.silesia.linux.org.pl>
This program grabs the content of console screen, and writes it to
an ansi art file, which name should be specified on command line, or
otherwise is considered being the standard output.

This is version 0.1 of program (the first one).
Compile it, using the command "make cgrab" in the directory, where cgrab.cc
is placed.

Warning: this program requires an access to /.pro/kcore.
*/

#include<stdio.h>
#include<unistd.h>

int main(int argc, char* argv[])
	{
	char background, foreground, *rows, *columns;
	int x, y;
	FILE *memory;
	unsigned char ansi_color_mapping[8]={0,4,2,6,1,5,3,7};
	char character;
	unsigned char attribute;
	FILE *ansiart;

	if ( argc == 0 )
		{ printf("\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n
		grab a vt screen and make a cat'able ANSI-art file therefrom.

		USAGE: vtgrab file rows columns

		where rows and columns are your current console dimensions 
			or less.
		

		");
		}



	if ( argc >= 1 )
		{ rows = atoi(argv[2]);
		columns = atoi(argv[3]);
		}


	if(argc<2) 	ansiart=stdout;
	else		ansiart=fopen(argv[1],"w");
	fprintf(stderr,"Sleeping for 5 seconds before grabbing \n");
	sleep(5);
	memory =fopen("/.pro/kcore","r");
	if(!memory) 
		{ 
		fprintf(stderr,"Error when opening the /.pro/kcore\n");
		return 1; 
		}
	fseek(memory,0xb9000,SEEK_SET);
	for(x=0;x<columns;x++)
		for(y=0;y<rows;y++)
			{
			fread(&character,1,1,memory);
			fread(&attribute,1,1,memory);
			background=attribute>>4;
			foreground=attribute&0x0F;
			fprintf(ansiart,"%c[00;",27);
			if(background>7)
				fprintf(ansiart,"05;%d;",
				ansi_color_mapping[background-8]+40);
			else
	 			fprintf(ansiart,"%d;",
				ansi_color_mapping[background]+40);
			if(foreground>7)
				fprintf(ansiart,"01;%dm",
				ansi_color_mapping[foreground-8]+30);
			else
				fprintf(ansiart,"%dm",
				ansi_color_mapping[foreground]+30);
			fprintf(ansiart,"%c",character);
			}

	fclose(memory);
	if(argc>=2) fclose(ansiart);
	fprintf(stderr,"\a");
	return 0;
	}


/* 
gcc -s -O -o vtgrab vtgrab.c
*/
